import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random
import methodes as met
import library  as lib

# Exercice 1


A=np.array([[4,0],[0,2]])
b=np.array([-3,0])
u0=np.random.rand(2,1)
rho=0.3 #0.25 
eps=10**(-6)
tabu,taberr,it=met.gradfix_eps(A,b,u0,rho,eps)
print(taberr[it])



x=tabu[0,:it+1]
y=tabu[1,:it+1]
xinf=tabu[0,it]
yinf=tabu[1,it]

print('Valeur atteinte en ',it,' itérations: ',xinf,yinf) 

theta=np.linspace(0,2*np.pi,101)
tabc=np.linspace(-25/8,8,10)
for c in tabc:
    r=np.sqrt(c+25/8)
    yt=r*np.sin(theta)
    r=r/np.sqrt(2)
    xt=-3/4+r*np.cos(theta)
    pl.plot(xt,yt,linewidth=0.5,color='black')
pl.plot(x,y,linewidth=0.5,color='red')
pl.plot([xinf,xinf],[yinf-0.01,yinf+0.01],linewidth=1,color='red')
pl.plot([xinf-0.01,xinf+0.01],[yinf,yinf],linewidth=2,color='red')

c=lib.f1(xinf,yinf)
r=np.sqrt(c+25/8)
yt=r*np.sin(theta)
r=r/np.sqrt(2)
xt=-3/4+r*np.cos(theta)
pl.plot(xt,yt,linewidth=0.5,color='red')

#
tabu,taberr,it=met.gradopt_eps(A,b,u0,eps)
print(taberr[it])

x=tabu[0,:it+1]
y=tabu[1,:it+1]
xinf=tabu[0,it]
yinf=tabu[1,it]

print('Valeur atteinte en ',it,' itérations: ',xinf,yinf) 

theta=np.linspace(0,2*np.pi,101)
tabc=np.linspace(-25/8,8,10)
for c in tabc:
    r=np.sqrt(c+25/8)
    yt=r*np.sin(theta)
    r=r/np.sqrt(2)
    xt=-3/4+r*np.cos(theta)
    pl.plot(xt,yt,linewidth=0.5,color='black')
pl.plot(x,y,linewidth=0.5,color='green')
pl.plot([xinf,xinf],[yinf-0.01,yinf+0.01],linewidth=1,color='green')
pl.plot([xinf-0.01,xinf+0.01],[yinf,yinf],linewidth=2,color='green')

c=lib.f1(xinf,yinf)
r=np.sqrt(c+25/8)
yt=r*np.sin(theta)
r=r/np.sqrt(2)
xt=-3/4+r*np.cos(theta)
pl.plot(xt,yt,linewidth=0.5,color='green')


pl.show()
pl.close()

##
tabu,taberr,it=met.gradopt_eps(A,b,u0,eps)
print(taberr[it])

x=tabu[0,:it+1]
y=tabu[1,:it+1]
xinf=tabu[0,it]
yinf=tabu[1,it]

print('Valeur atteinte en ',it,' itérations: ',xinf,yinf) 

theta=np.linspace(0,2*np.pi,101)
tabc=np.linspace(0.5,10,10)
for c in tabc:
    r=np.sqrt(c)
    yt=1+r*np.sin(theta)
    xt=r*np.cos(theta)
    pl.plot(xt,yt,linewidth=0.5,color='black')
pl.plot(x,y,linewidth=0.5,color='green')
pl.plot([xinf,xinf],[yinf-0.01,yinf+0.01],linewidth=1,color='green')
pl.plot([xinf-0.01,xinf+0.01],[yinf,yinf],linewidth=2,color='green')

c=lib.f2(xinf,yinf)
r=np.sqrt(c)
yt=1+r*np.sin(theta)
xt=r*np.cos(theta)
pl.plot(xt,yt,linewidth=0.5,color='green')

pl.show()
pl.close()



