import numpy as np
import pylab as pl
import math
import scipy as sp
from scipy import linalg,random
import methodes as met
import library  as lib


    
rho=0.15
eps=10**(-6)
x0=np.array([0,0])
tabx,taberr,it=met.gradfi2(lib.df4,x0,rho,eps)
#tabx,taberr,it=gradfiopt(f4,df4,x0,eps)
print(it,' itérations')
print('Précision atteinte: ',taberr[it])

x=tabx[0,:it+1]
y=tabx[1,:it+1]
xinf=tabx[0,it]
yinf=tabx[1,it]

print('Valeur atteinte en ',it,' itérations: ',xinf,yinf) 


theta=np.linspace(0,np.pi,101)
xt=3*(1+np.cos(theta))/2
yt=2*np.sin(theta)
pl.plot(xt,yt,linewidth=0.5,color='black')

pl.plot(x,y,linewidth=0.5,color='red')
pl.plot([xinf,xinf],[yinf-0.01,yinf+0.01],linewidth=1,color='red')
pl.plot([xinf-0.01,xinf+0.01],[yinf,yinf],linewidth=2,color='red')

pl.show()
pl.close()


taba=np.linspace(0,10,11)

for a in taba:
    theta=np.linspace(0,np.pi,100)
    y=np.array([lib.f4([a,theta[i]]) for i in range(100)])
    pl.plot(theta,y,linewidth=0.5,color='black')
pl.show()
pl.close()


a0=1
tabt=np.linspace(0,np.pi,11)

for theta0 in tabt:
    x0=np.array([a0,theta0])
    tabx,taberr,it=met.gradfi2(lib.df4,x0,rho,eps)
    a=tabx[0,:it+1]
    theta=tabx[1,:it+1]
    r=np.array([0.5+math.atan(a[i])/np.pi for i in range(it+1)])
    x=np.array([3*(1+r[i]*np.cos(theta[i]))/2 for i in range(it+1)])
    y=np.array([2*r[i]*np.sin(theta[i]) for i in range(it+1)])
    pl.plot(x,y,linewidth=0.5,color='black')
    x0=x[it]
    y0=y[it]
    pl.plot([x0,x0],[y0-0.01,y0+0.01],linewidth=1,color='red')
    pl.plot([x0-0.01,x0+0.01],[y0,y0],linewidth=1,color='red')
theta=np.linspace(0,np.pi,101)
xt=3*(1+np.cos(theta))/2
yt=2*np.sin(theta)
pl.plot(xt,yt,linewidth=0.5,color='black')

#
a0=-1
tabt=np.linspace(0,np.pi,11)

for theta0 in tabt:
    x0=np.array([a0,theta0])
    tabx,taberr,it=met.gradfi2(lib.df4,x0,rho,eps)
    a=tabx[0,:it+1]
    theta=tabx[1,:it+1]
    r=np.array([0.5+math.atan(a[i])/np.pi for i in range(it+1)])
    x=np.array([3*(1+r[i]*np.cos(theta[i]))/2 for i in range(it+1)])
    y=np.array([2*r[i]*np.sin(theta[i]) for i in range(it+1)])
    pl.plot(x,y,linewidth=0.5,color='black')
    x0=x[it]
    y0=y[it]
    pl.plot([x0,x0],[y0-0.01,y0+0.01],linewidth=1,color='red')
    pl.plot([x0-0.01,x0+0.01],[y0,y0],linewidth=1,color='red')
theta=np.linspace(0,np.pi,101)
xt=3*(1+np.cos(theta))/2
yt=2*np.sin(theta)
pl.plot(xt,yt,linewidth=0.5,color='black')


##
a0=10
tabt=np.linspace(0,np.pi,11)

for theta0 in tabt:
    x0=np.array([a0,theta0])
    tabx,taberr,it=met.gradfi2(lib.df4,x0,rho,eps)
    a=tabx[0,:it+1]
    theta=tabx[1,:it+1]
    r=np.array([0.5+math.atan(a[i])/np.pi for i in range(it+1)])
    x=np.array([3*(1+r[i]*np.cos(theta[i]))/2 for i in range(it+1)])
    y=np.array([2*r[i]*np.sin(theta[i]) for i in range(it+1)])
    pl.plot(x,y,linewidth=0.5,color='black')
    x0=x[it]
    y0=y[it]
    pl.plot([x0,x0],[y0-0.01,y0+0.01],linewidth=1,color='red')
    pl.plot([x0-0.01,x0+0.01],[y0,y0],linewidth=1,color='red')
theta=np.linspace(0,np.pi,101)
xt=3*(1+np.cos(theta))/2
yt=2*np.sin(theta)
pl.plot(xt,yt,linewidth=0.5,color='black')


###
a0=100
tabt=np.linspace(0,np.pi,11)

for theta0 in tabt:
    x0=np.array([a0,theta0])
    tabx,taberr,it=met.gradfi2(lib.df4,x0,rho,eps)
    a=tabx[0,:it+1]
    theta=tabx[1,:it+1]
    r=np.array([0.5+math.atan(a[i])/np.pi for i in range(it+1)])
    x=np.array([3*(1+r[i]*np.cos(theta[i]))/2 for i in range(it+1)])
    y=np.array([2*r[i]*np.sin(theta[i]) for i in range(it+1)])
    pl.plot(x,y,linewidth=0.5,color='black')
    x0=x[it]
    y0=y[it]
    pl.plot([x0,x0],[y0-0.01,y0+0.01],linewidth=1,color='red')
    pl.plot([x0-0.01,x0+0.01],[y0,y0],linewidth=1,color='red')
theta=np.linspace(0,np.pi,101)
xt=3*(1+np.cos(theta))/2
yt=2*np.sin(theta)
pl.plot(xt,yt,linewidth=0.5,color='black')

pl.show()
pl.close()


####
taba0=np.linspace(0,100,101)

for a0 in taba0:
    for theta0 in tabt:
        x0=np.array([a0,theta0])
        tabx,taberr,it=met.gradfi2(lib.df4,x0,rho,eps)
        a=tabx[0,:it+1]
        theta=tabx[1,:it+1]
        r=np.array([0.5+math.atan(a[i])/np.pi for i in range(it+1)])
        x=np.array([3*(1+r[i]*np.cos(theta[i]))/2 for i in range(it+1)])
        y=np.array([2*r[i]*np.sin(theta[i]) for i in range(it+1)])
        pl.plot(x,y,linewidth=0.5,color='black')
        x0=x[it]
        y0=y[it]
        pl.plot([x0,x0],[y0-0.01,y0+0.01],linewidth=1,color='red')
        pl.plot([x0-0.01,x0+0.01],[y0,y0],linewidth=1,color='red')

a0=-1

for theta0 in tabt:
    x0=np.array([a0,theta0])
    tabx,taberr,it=met.gradfi2(lib.df4,x0,rho,eps)
    a=tabx[0,:it+1]
    theta=tabx[1,:it+1]
    r=np.array([0.5+math.atan(a[i])/np.pi for i in range(it+1)])
    x=np.array([3*(1+r[i]*np.cos(theta[i]))/2 for i in range(it+1)])
    y=np.array([2*r[i]*np.sin(theta[i]) for i in range(it+1)])
    pl.plot(x,y,linewidth=0.5,color='black')
    x0=x[it]
    y0=y[it]
    pl.plot([x0,x0],[y0-0.01,y0+0.01],linewidth=1,color='red')
    pl.plot([x0-0.01,x0+0.01],[y0,y0],linewidth=1,color='red')

theta=np.linspace(0,np.pi,101)
xt=3*(1+np.cos(theta))/2
yt=2*np.sin(theta)
pl.plot(xt,yt,linewidth=0.5,color='black')


pl.show()
pl.close()



    
    
