import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random
import methodes as met
import library  as lib

# Exercice 2


x=np.linspace(0,2,201)
y=lib.f3(x)
pl.plot(x,y,linewidth=0.5,color='black')
#pl.show()
#pl.close()


x0=-1+np.random.rand(1)  #1+np.random.rand(1) #0.2
eps=10**(-3)

tabrho=np.array([0.15, 0.1, 0.01])
#rho=0.01 # 0.1 #0.15
for rho in tabrho:
    tabx,taberr,it=met.gradfi(lib.f3p,x0,rho,eps)
    print('rho= ',rho)
    print('Nombre d''itérations: ',it)
    print('Erreur: ',taberr[it])
    xsol=tabx[it]
    ysol=lib.f3(xsol)
    print('Solution: ',xsol)
    print('Valeur de f atteinte: ', ysol)
pl.plot([xsol,xsol],[ysol-0.02,ysol+0.02],linewidth=2.5,color='red')
pl.plot([xsol-0.01,xsol+0.01],[ysol,ysol],linewidth=2.5,color='red')
pl.show()
pl.close()

eps=10**(-6)
tabx,taberr,it=met.gradfiopt(lib.f3,lib.f3p,x0,eps)
print('Nombre d''itérations: ',it)
print('Erreur: ',taberr[it])
xsol=tabx[it]
ysol=lib.f3(xsol)
print('Solution: ',xsol)
print('Valeur de f atteinte: ', ysol)
pl.plot(x,y,linewidth=0.5,color='black')
pl.plot([xsol,xsol],[ysol-0.02,ysol+0.02],linewidth=2.5,color='red')
pl.plot([xsol-0.01,xsol+0.01],[ysol,ysol],linewidth=2.5,color='red')
pl.show()
pl.close()
