import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random
import methodes as met
import library  as lib

# Exercice 3

theta=np.linspace(0,2*np.pi,100)
x=np.cos(theta)
y=np.sin(theta)
pl.plot(x,y,linewidth=0.5,color='black')
u=np.linspace(-2,3,501)
v=np.ones(501)-u
pl.plot(u,v,linewidth=0.5,color='black')
pl.plot([0,0],[-2,3],[-2,3],[0,0],linewidth=0.5,color='grey')



eps=10**(-6)
x0=np.array([0,0])
#tabrho=[0.1,0.15,0.2,0.3]
rho=0.05

tabx,taberr,taber,it=met.gradfiproj(lib.dg,x0,rho,eps)
print(it,' itérations')
print('Précision atteinte: ',taberr[it])

x1=tabx[0,:it+1]
x2=tabx[1,:it+1]
pl.plot(x1,x2,linewidth=0.5,color='red')
xinf=x1[-1]
yinf=x2[-1]
cinf=lib.g(xinf,yinf)
w=lib.gc(u,cinf)
pl.plot(u,w,linewidth=0.5,color='green')
pl.plot([xinf,xinf],[yinf-0.01,yinf+0.01],linewidth=5,color='red')
pl.plot([xinf-0.01,xinf+0.01],[yinf,yinf],linewidth=5,color='red')


#


x0=np.array([1,1])
#tabrho=[0.1,0.15,0.2,0.3]
rho=0.05

tabx,taberr,taber,it=met.gradfiproj(lib.dg,x0,rho,eps)
print(it,' itérations')
print('Précision atteinte: ',taberr[it])

x1=tabx[0,:it+1]
x2=tabx[1,:it+1]
pl.plot(x1,x2,linewidth=0.5,color='red')
xinf=x1[-1]
yinf=x2[-1]
cinf=lib.g(xinf,yinf)
w=lib.gc(u,cinf)
pl.plot(u,w,linewidth=0.5,color='green')
pl.plot([xinf,xinf],[yinf-0.01,yinf+0.01],linewidth=5,color='red')
pl.plot([xinf-0.01,xinf+0.01],[yinf,yinf],linewidth=5,color='red')

#
x0=np.array([-2,0])
#tabrho=[0.1,0.15,0.2,0.3]
rho=0.05

tabx,taberr,taber,it=met.gradfiproj(lib.dg,x0,rho,eps)
print(it,' itérations')
print('Précision atteinte: ',taberr[it])

x1=tabx[0,:it+1]
x2=tabx[1,:it+1]
pl.plot(x1,x2,linewidth=0.5,color='red')
xinf=x1[-1]
yinf=x2[-1]
cinf=lib.g(xinf,yinf)
w=lib.gc(u,cinf)
pl.plot(u,w,linewidth=0.5,color='green')
pl.plot([xinf,xinf],[yinf-0.01,yinf+0.01],linewidth=5,color='red')
pl.plot([xinf-0.01,xinf+0.01],[yinf,yinf],linewidth=5,color='red')

pl.show()
pl.close()

#
v=(np.sign(u)+1)/2
pl.plot(u,v,linewidth=0.5,color='black')
pl.plot([0,0],[-2,3],[-2,3],[0,0],linewidth=0.5,color='grey')
pl.show()
pl.close()

##
eps=10**(-6)
x0=np.array([0,0])
tabx,taberr,it=met.gradfioptb(lib.f1b,lib.df1b,x0,eps)
print(it,' itérations')
print('Précision atteinte: ',taberr[it])

x=tabx[0,:it+1]
y=tabx[1,:it+1]
xinf=tabx[0,it]
yinf=tabx[1,it]

print('Valeur atteinte en ',it,' itérations: ',xinf,yinf) 

theta=np.linspace(0,2*np.pi,101)
tabc=np.linspace(-25/8,8,10)
for c in tabc:
    r=np.sqrt(c+25/8)
    yt=r*np.sin(theta)
    r=r/np.sqrt(2)
    xt=-3/4+r*np.cos(theta)
    pl.plot(xt,yt,linewidth=0.5,color='black')
pl.plot(x,y,linewidth=0.5,color='red')
pl.plot([xinf,xinf],[yinf-0.01,yinf+0.01],linewidth=1,color='red')
pl.plot([xinf-0.01,xinf+0.01],[yinf,yinf],linewidth=2,color='red')


c=lib.f1b([xinf,yinf])
r=np.sqrt(c+25/8)
yt=r*np.sin(theta)
r=r/np.sqrt(2)
xt=-3/4+r*np.cos(theta)
pl.plot(xt,yt,linewidth=0.5,color='red')

pl.show()
pl.close()

##
eps=10**(-6)
x0=np.array([0,0])
tabx,taberr,it=met.gradfioptb(lib.f2b,lib.df2b,x0,eps)
print(it,' itérations')
print('Précision atteinte: ',taberr[it])

x=tabx[0,:it+1]
y=tabx[1,:it+1]
xinf=tabx[0,it]
yinf=tabx[1,it]

print('Valeur atteinte en ',it,' itérations: ',xinf,yinf) 

theta=np.linspace(0,2*np.pi,101)
tabc=np.linspace(0.5,10,10)
for c in tabc:
    r=np.sqrt(c)
    yt=1+r*np.sin(theta)
    xt=r*np.cos(theta)
    pl.plot(xt,yt,linewidth=0.5,color='black')
pl.plot(x,y,linewidth=0.5,color='red')
pl.plot([xinf,xinf],[yinf-0.01,yinf+0.01],linewidth=1,color='red')
pl.plot([xinf-0.01,xinf+0.01],[yinf,yinf],linewidth=2,color='red')

c=lib.f2b([xinf,yinf])
r=np.sqrt(c)
yt=1+r*np.sin(theta)
xt=r*np.cos(theta)
pl.plot(xt,yt,linewidth=0.5,color='red')

pl.show()
pl.close()


