////////// question3.sce //////////
// exec question3.sce

clear
exec methodes.sci
exec library.sci

deff('z=g(x,y)','z=y^2-x')

x=-3:0.1:3;
y=x;

close()
fplot3d(x,y,g)


eps=1e-3;
x0=[0;0];

tabrho=[0.1 0.15 0.2 0.3];

//close()

rho=0.05;
[tabx,taberr,taber]=gradfiproj(dg,x0,rho,eps);


x=tabx(:,$)
err=taberr($)
iter=length(taberr)

taberr=log(taberr);
t=log(1:iter);

t($)=[];
taber($)=[];
taber=log(taber);

close()
plot(taberr,'+')
plot(taber,'+')


for rho=tabrho
//rho=0.3; //0.4; //0.2; //0.1; //0.15;
[tabx,taberr,taber]=gradfiproj(dg,x0,rho,eps);

x=tabx(:,$)
err=taberr($)
iter=length(taberr)

taberr=log(taberr);
t=log(1:iter);

t($)=[];
taber($)=[];
taber=log(taber);


close()
plot(taberr,'o-')
plot(taber,'o-')

end

rho=0.4;
[tabx,taberr,taber]=gradfiproj(dg,x0,rho,eps);

x=tabx(:,$)
err=taberr($)
iter=length(taberr)

taberr=log(taberr);
t=log(1:iter);

t($)=[];
taber($)=[];
taber=log(taber);


close()
plot(taberr,'r')
plot(taber,'r')

title('Erreur vs le nombre de pas en partant de  (0,0)')
xlabel('Nombre de pas')
ylabel('Erreur')

legend('rho=0.05','rho=0.1','rho=0.15',...
     'rho= 0.2','rho=0.3','rho=0.4')


x=tabx(1,:);
y=tabx(2,:);
size(g(x,y))
size(tabx)

close()

t=-3:0.1:3;
contour2d(t,t,g,g(x,y));
plot(x,y)

rho=0.4;

[tabx,tabx2]=gradfip(dg,x0,rho,eps);

x=tabx(1,:);
y=tabx(2,:);

x2=tabx2(1,:);
y2=tabx2(2,:);


close()

t=-3:0.1:3;
contour2d(t,t,g,g(x,y));
plot(x,y)

contour2d(t,t,g,g(x2,y2));
plot(x2,y2,'r')

//close()

//t=-3:0.1:3;
//[x,y]=meshgrid(t,t);
//z=x.^2-y;
//mesh(x,y,z);


close()


t=-1:0.01:1;

lambda=-6;
y=t.^2-lambda;
z=sqrt(1-t.^2);
plot(t,z,'r')
z=-z;
plot(t,z,'r')


//plot(t,y)

y=1-t;
plot(t,y,'r')

for lambda=-5:5
y=t.^2-lambda;
plot(t,y)
end


rho=0.4;
x0=[0;0];
eps=1e-3;
N=5;
param=1;
close()

[tabx,taberr,taber]=gradfiproj(dg,x0,rho,eps);
x=tabx(:,$);
x1=x(1);
x2=x(2);
plot(x1,x2,'o')

lambda=x1^2-x2;
y=t.^2-lambda;
plot(t,y)


for k=1:N


[tabx,taberr,taber]=gradfipe(dg,dgK,x0,rho,eps,param);

err=taberr($)
x=tabx(:,$)
iter=length(taberr)
param=param/2;

x1=x(1);
x2=x(2);
plot(x1,x2,'o')

lambda=x1^2-x2;
y=t.^2-lambda;
plot(t,y)

close()
plot(taberr,'o-')

end

